/*	
 *	clipwsg.h
 *
 *	P/ECE Namco WSG Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Sun Feb 15 04:29:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_WSG_H__
#define __CLIP_WSG_H__

/****************************************************************************
 *
 ****************************************************************************/

#define WSGBUFLEN 320 /* = 16000/50 c 1[tick](=1/50[sec])̃Tv */

typedef struct _WSG WSG;

/*
 *	WSG`l
 */
typedef struct _WSGCHANNEL {
	int volume;			/* + 0,4: {[ (0`15) */
	int frequency;			/* + 4,4: g           (17.15bitŒ菬) */
	int progress;			/* + 8,4: g`isJE^ (17.15bitŒ菬) */
	char* wave/*[0x20]*/;		/* +12,4: g`f[^̐擪AhX */
} WSGCHANNEL;				/* =16 */

/*
 *	WSGRA
 */
/*typedef*/ struct _WSG {
	unsigned char reg[0x40];	/* WX^l */
	char wavetable[8][0x20];	/* g`e[u (Tvl:-8`+7) */
	//
	WSGCHANNEL channel[8];		/* `l */
	//
	DDA clock_progress;		/* NbNisDDA */
} /*WSG*/;

/****************************************************************************
 *	֐
 ****************************************************************************/

//int wsg_process(WSG* wsg, int cycle);̂߁Awsg_mix()̒Ɋ܂߂܂B
int wsg_channel_process(WSG* wsg, WSGCHANNEL* channel, int cycle);

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

/* WSGRAZbg܂B
 * [in]
 *	wsg		WSG\́B
 *	clock		TvONbNB
 *	wavetable	g`e[uւ̃|C^B
 * [note]
 *	* AvP[VvÓAȂƂŏɈxÅ֐ĂяoĂB
 *	  ̌́AWSGZbgsꍇɁAKvɉČĂяoĂB
 *	* g`e[ǔ`́A̒ʂłB
 *	  E1Tv1oCgA4bit̂ݎgpBTvl0`15B
 *	  E1g`32TvB8g`̃e[uB
 *	  E]āAg`e[uŜ̃TCY32~8=256oCgłB
 *	* wsg_reset()̒Ŕg`e[ũRs[쐬܂B
 *	  wsg_reset()ԂAĂяo͔g`e[ujč\܂B
 */
void wsg_reset(WSG* wsg, int clock, const void* wavetable/*[0x100]*/);

/* WX^l݂܂B
 * [in]
 *	wsg		WSG\́B
 *	addr		WX^AhXB
 *	data		WX^lB
 */
void wsg_write_pengo(WSG* wsg, int addr, unsigned char data); /* Pengo type  */
void wsg_write_mappy(WSG* wsg, int addr, unsigned char data); /* Mappy type */
#define wsg_write wsg_write_mappy /* Mappy type Ƃ邱Ƃɂ܂ */

/* o̓TvO[g=SPEAKER_OUTPUT[Hz]ŁAw肳ꂽTṽ~LVOs܂B
 * [in]
 *	wsg		WSG\́B
 *	wbuff		o̓Tvobt@B
 *	count		o̓TvB
 */
void wsg_mix(WSG* wsg, short wbuff[/*count*/], int count);

#endif /*__CLIP_WSG_H__*/
