/*
 *	app.h
 *
 *	WSGvC[
 *
 *	* Sun Feb 15 15:01:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <clip.h>

#define M6809_CLOCK	(640*480*60/ 12) /*=1.536MHz M6809NbN       */
#define WSG_CLOCK	(640*480*60/768) /*=24000 Hz WSGTvONbN */
#define IRQ_INTERVAL	((int)(M6809_CLOCK / 60.606060)) /* IRQTCN  */

typedef struct _DRIVER {
	/*{{CAEgŒ*/
	M6809 m6809;
	unsigned char mem[0x10000];
	/*}}CAEgŒ*/
	//
	WSG wsg;
	unsigned char wavetable[0x100];
	//
	int irq_cycle; /* IRQ܂ł̎cTCN */
} DRIVER;
extern DRIVER g_driver;

void m6809_write(M6809* m6809, unsigned short addr, unsigned char data);

typedef struct _ROMSET {
	int year;					/* N */
	const char* name;				/* Q[ */
	const char* file;				/* ROMZbgt@C (NULL:Ή) */
	const ROM* program_roms;			/* vOROM */
	int num_program_roms;				/* vOROM */
	const ROM* wavetable_roms;			/* WaveTable ROM */
	int num_wavetable_roms;				/* WaveTable ROM */
	int num_tracks;					/* gbN */
	void (*init)(DRIVER* driver);			/* [` */
} ROMSET;

int file_sel(DRIVER* driver, int i_file);
void track_sel(DRIVER* driver, const ROMSET* romset);
void driver_play(DRIVER* driver, const ROMSET* romset, int i_track);
void driver_stop(DRIVER* driver, const ROMSET* romset);
int stream_callback(short wbuff[], int param);
void driver_mix(DRIVER* driver, short wbuff[/*WSGBUFLEN*/]);
void driver_mix2(DRIVER* driver, short wbuff[/*WSGBUFLEN*/]);

